#!/bin/bash 

echo "Edite o arquivo para continuar"
exit 1

# Editar as variáveis abaixo
export GCCROOT=/home/pedropl/openacc/SCelementary
export CUDA=/home/pedropl/stuff/cuda-7.5
# Se a variável abaixo for 1, então versão é de snapshot
#           majorversion-anomesdia do snapshot
#      Verificar snapshot disponível em http://mirrors.concertpass.com/gcc/snapshots/
# Caso contrário a versão é a numeração do GCC
snapshot=0
version=5.4.0
#version=6-20170202

# Não editar a partir daqui...
echo; echo "Baixando nvptx-newlib nvptx-tools gcc-$version"
#read a
mkdir $GCCROOT/source
cd $GCCROOT/source
git clone https://github.com/MentorEmbedded/nvptx-newlib.git
git clone https://github.com/MentorEmbedded/nvptx-tools.git
if [ $snapshot = 0 ]; then
	wget -c http://mirrors.concertpass.com/gcc/releases/gcc-$version/gcc-$version.tar.bz2
else
	wget -c http://mirrors.concertpass.com/gcc/snapshots/LATEST-$(echo $version | awk -F\- '{print $1}')/gcc-$version.tar.bz2
fi
tar jxvf gcc-$version.tar.bz2
mkdir -p $GCCROOT/build/nvptx-build
cd $GCCROOT/build/nvptx-build

echo; echo "Configurando nvptx-tools"
#read a
$GCCROOT/source/nvptx-tools/configure  \
  --prefix=$GCCROOT/install-gcc-$version \
  --target=nvptx-none \
  --with-cuda-driver-include=$CUDA/include \
  --with-cuda-driver-lib=/usr/lib64/nvidia \
  --with-cuda-runtime-include=$CUDA/include \
  --with-cuda-runtime-lib=$CUDA/lib64 \
  CC='gcc -m64' \
  CXX='g++ -m64'

echo; echo "Compilando nvptx-tools"
#read a
make -j 16
echo; echo "Instalando nvptx-tools"
#read a
make install



echo; echo "Configurando gcc-${version}-accel"
#read a
mkdir -p $GCCROOT/build/gcc-${version}-accel
cd $GCCROOT/build/gcc-${version}-accel

ln -vs $GCCROOT/source/nvptx-newlib/newlib $GCCROOT/source/gcc-$version/newlib
ln -vs . $GCCROOT/install-gcc-$version/nvptx-none/usr
target=$($GCCROOT/source/gcc-$version/config.guess)

$GCCROOT/source/gcc-$version/configure \
  --prefix= \
  --target=nvptx-none \
  --enable-as-accelerator-for="$target" \
  --enable-languages=c,c++,fortran,lto \
  --enable-checking=yes,df,fold,rtl \
  --disable-multilib \
  --with-sysroot=/nvptx-none \
  --with-build-sysroot=$GCCROOT/install-gcc-$version/nvptx-none \
  --with-build-time-tools=$GCCROOT/install-gcc-$version/nvptx-none/bin \
  --disable-sjlj-exceptions \
  --enable-newlib-io-long-long \
  CC='gcc -m64'\
  CXX='g++ -m64'

echo; echo "Compilando gcc-${version}-accel"
#read a
make -j 16
echo; echo "Instalando gcc-${version}-accel"
#read a
make DESTDIR=$GCCROOT/install-gcc-$version install

echo; echo "Configurando gcc-${version}"
#read a
mkdir -p $GCCROOT/build/gcc-$version
cd $GCCROOT/build/gcc-$version

$GCCROOT/source/gcc-$version/configure \
  --prefix= \
  --disable-bootstrap \
  --enable-languages=c,c++,fortran,lto \
  --disable-multilib \
  --enable-offload-targets=nvptx-none=$GCCROOT/install-gcc-$version \
  --with-cuda-driver-include=$CUDA/include \
  CC='gcc -m64' \
  CXX='g++ -m64' \
  --with-sysroot=

echo; echo "Compilando gcc-${version}"
#read a
make -j 16
echo; echo "Instalando gcc-${version}"
#read a
make DESTDIR=$GCCROOT/install-gcc-$version install

echo; echo "Configurando envrc"
#read a
cat << EOF > $GCCROOT/envrc-$version
export GCCROOT=$GCCROOT
export PATH=\$GCCROOT/install-gcc-$version/bin:\$PATH
export LIBRARY_PATH=\$GCCROOT/install-gcc-$version/lib64:\$LIBRARY_PATH
export LD_LIBRARY_PATH=\$GCCROOT/install-gcc-$version/lib64:\$LD_LIBRARY_PATH
export CPLUS_INCLUDE_PATH=\$GCCROOT/install-gcc-$version/include/c++/$version:\$CPLUS_INCLUDE_PATH
export MANPATH=\$GCCROOT/install-gcc-$version/$version/share/man:\$MANPATH
EOF

echo "Se não ocorreram problemas usar o GCC recém compilado com source $GCCROOT/envrc-$version"
